//+------------------------------------------------------------------+
//|                                                    autoTP_EA.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//|                                                   Writer: abc_fx |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern int Safe = 20;

extern int TP_1 = 25;
extern double Lot_1 = 0.02;


extern int TP_2 = 50;
extern int SL_2 = 25;
extern double Lot_2 = 0.02;

extern int TP_3 = 80;
extern int SL_3 = 50;
extern double Lot_3 = 0.02;

extern int TP_4 = 100;
extern double Lot_4 = 0.02;

extern int TrailingStop = 30;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   int count, total;
   RefreshRates();
   total=OrdersTotal();
   for(count=0;count<total;count++)
      {
      OrderSelect(count, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
      //1. Buy Orders
      if(OrderType()==OP_BUY && OrderSymbol()==Symbol())
         {
         //1.1 Move SL=Entry at Break point
         if(Bid-OrderOpenPrice()>Safe*10*Point && (OrderStopLoss()<OrderOpenPrice()||OrderStopLoss()==0))            
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,CLR_NONE);           
         //1.2 Take TP_1 (0.02 lot) at TP_1 = 25p. Note: Ticket Order changes 
         if(Bid-OrderOpenPrice()>TP_1*10*Point && OrderStopLoss()<=OrderOpenPrice())
            {
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+1*10*Point,OrderTakeProfit(),0,CLR_NONE);
            if (OrderLots()>0.01)               
               if (OrderClose(OrderTicket(),Lot_1,Bid,5*10*Point,CLR_NONE))
                  Comment("Chot ",Lot_1," lot tai ",Bid,"!");           
            }
         //1.3 Take TP_2 (0.02 lot) at TP_2 = 50p. Move SL to SL_2=25p
         if(Bid-OrderOpenPrice()>TP_2*10*Point && OrderStopLoss()==OrderOpenPrice()+1*10*Point)
            {
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+SL_2*10*Point,OrderTakeProfit(),0,CLR_NONE);                   
            if (OrderLots()>0.01)               
               if (OrderClose(OrderTicket(),Lot_2,Bid,5*10*Point,CLR_NONE))
                  Comment("\n","Chot ",Lot_2," lot tai ",Bid,"!");            
            }
         //1.4 Takde TP_3 (0.02 lot) at TP_3 = 80p. Move SL to SL_3=50p
         if(Bid-OrderOpenPrice()>TP_3*10*Point && OrderStopLoss()==OrderOpenPrice()+SL_2*10*Point)
            {
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+SL_3*10*Point,OrderTakeProfit(),0,CLR_NONE);                  
            if (OrderLots()>0.01)               
               if (OrderClose(OrderTicket(),Lot_3,Bid,5*10*Point,CLR_NONE))
                  Comment("\n","Chot ",Lot_3," lot tai ",Bid,"!");
            }
         //1.5 Take TP_4 (0.02 lot) at TP_4 = 100p. Don't move SL!
         if(Bid-OrderOpenPrice()>TP_4*10*Point && OrderStopLoss()==OrderOpenPrice()+SL_3*10*Point)
            {
            if (OrderLots()>0.01)              
               if (OrderClose(OrderTicket(),Lot_4,Bid,5*10*Point,CLR_NONE))
                  Comment("\n","Chot ",Lot_4," lot tai ",Bid,"!");
            }
         //1.6 Change to Trailing Stop Mode.
         if(Bid-OrderOpenPrice()>(TP_4+TrailingStop)*10*Point)
            {
            if(OrderStopLoss()<Bid-TrailingStop*10*Point)               
               OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TrailingStop*10*Point,OrderTakeProfit(),0,CLR_NONE);           
            }         
         }
      //2. Sell Orders   
      if(OrderType()==OP_SELL && OrderSymbol()==Symbol())
         {
         //2.1 Move SL=Entry at Break point
         if(OrderOpenPrice()-Ask>Safe*10*Point && (OrderStopLoss()>OrderOpenPrice()||OrderStopLoss()==0))            
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,CLR_NONE);           
         //2.2 Take TP_1 (0.02 lot) at TP_1 = 25p. Note: Ticket Order changes
         if(OrderOpenPrice()-Ask>TP_1*10*Point && OrderStopLoss()>=OrderOpenPrice())
            {
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-1*10*Point,OrderTakeProfit(),0,CLR_NONE);
            if (OrderLots()>0.01)               
               if (OrderClose(OrderTicket(),Lot_1,Ask,5*10*Point,CLR_NONE))
                  Comment("Chot ",Lot_1," lot tai ",Ask,"!");
            }
         //2.3 Take TP_2 (0.02 lot) at TP_2 = 50p. Move SL to SL_2=25p
         if(OrderOpenPrice()-Ask>TP_2*10*Point && OrderStopLoss()==OrderOpenPrice()-1*10*Point)
            {
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-SL_2*10*Point,OrderTakeProfit(),0,CLR_NONE);                   
            if (OrderLots()>0.01)               
               if (OrderClose(OrderTicket(),Lot_2,Ask,5*10*Point,CLR_NONE))
                  Comment("\n","Chot ",Lot_2," lot tai ",Ask,"!");
            }
         //2.4 Takde TP_3 (0.02 lot) at TP_3 = 80p. Move SL to SL_3=50p
         if(OrderOpenPrice()-Ask>TP_3*10*Point && OrderStopLoss()==OrderOpenPrice()-SL_2*10*Point)
            {
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-SL_3*10*Point,OrderTakeProfit(),0,CLR_NONE);                  
            if (OrderLots()>0.01)               
               if (OrderClose(OrderTicket(),Lot_3,Ask,5*10*Point,CLR_NONE))
                  Comment("\n","Chot ",Lot_3," lot tai ",Ask,"!");               
            }
         //2.5 Take TP_4 (0.02 lot) at TP_4 = 100p. Don't move SL!
         if(OrderOpenPrice()-Ask>TP_4*10*Point && OrderStopLoss()==OrderOpenPrice()-SL_3*10*Point)
            {
            if (OrderLots()>0.01)                          
               if (OrderClose(OrderTicket(),Lot_4,Ask,5*10*Point,CLR_NONE))
                  Comment("\n","Chot ",Lot_4," lot tai ",Ask,"!");
            }
         //2.6 Change to Trailing Stop Mode.
         if(OrderOpenPrice()-Ask>(TP_4+TrailingStop)*10*Point)
            {
            if(OrderStopLoss()>Ask+TrailingStop*10*Point)               
               OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TrailingStop*10*Point,OrderTakeProfit(),0,CLR_NONE);               
            }
         }      
      }  
   return(0);
  }
//+------------------------------------------------------------------+